package app

import (
	"ArmedPolice/app/event"
	"ArmedPolice/app/service"
	"ArmedPolice/config"
	"ArmedPolice/lib"
)

func Init() {
	// 载入数据配置
	lib.LoadConfig("./json/area.json", &config.SettingAreaInfo)
	// RedisHash存储/移除监听
	service.Subscribe(config.EventForRedisHashProduce, event.NewRedisHashProduce())
	service.Subscribe(config.EventForRedisHashDestroy, event.NewRedisHashDestroy())
	// RedisList存储/移除监听
	service.Subscribe(config.EventForRedisListProduce, event.NewRedisListProduce())
	service.Subscribe(config.EventForRedisListDestroy, event.NewRedisListDestroy())
}
